<?php

/*
   Das Editieren dieser Datei ist nicht gestattet!
   Editing of this file is not allowed!
*/

function selbstdiagnose($target) {
  global $PROGRAM;
  echo "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">\n\n<HTML>\n\n<HEAD>\n\t".'<meta name="robots" content="NOINDEX, NOFOLLOW"><title>Self-Test Logfile</title>'."\n
  \t".'<style type="text/css">.kommentar { color: #808080 } BODY { background: #FFFFFF; color: #000000; font-family: serif } H1 { font-family: sans-serif; background: #DDE5FA } H2 { font-family: sans-serif; background: #EEEEEE }</style>'."\n</HEAD>\n\n
  <BODY>
  
  <H1>Self-Test Logfile</H1>
  
  <P class=kommentar align=justify><STRONG>Anleitung:</STRONG> Dieses Skript fhrt eine Reihe von Tests zur Selbstdiagnose durch, um festzustellen,
                     ob Ihr Programm korrekt installiert wurde. Sie knnen diese Log-Datei selbst auf Fehlermeldungen untersuchen - oder aber,
                     falls das Programm dennoch nicht funktioniert, knnen Sie mir auch eine E-Mail senden, um Hilfe bei der Lsung
                     Ihres Problems zu erhalten. Wenn Sie Fragen via Mail stellen, hngen Sie bitte dieses Diagnoseprotokoll an Ihre Mail.
                     Viele typische Fehler lassen sich bereits aus diesem Protokoll erkennen und Sie erhalten schneller eine Antwort.</P>
  <P class=kommentar>&bull; Falls ein Test fehlschlgt, werden <font color=#FF0000>Fehlermeldungen</font> rot markiert.<BR>
                     &bull; Ist ein Test erfolgreich, werden <font color=#00A000>Besttigungsmeldungen</font> grn markiert.<BR>
                     &bull; Alle <font color=#000000>normalen Status-Informationen</font> werden schwarz dargestellt.</P>
  <P class=kommentar>Sollten Sie rote Zeilen finden: prfen Sie bitte Ihre Konfiguration auf die beschriebenen Fehler.<BR>
                     Bitte beachten Sie: dieses Programm erkennt zwar einige der <i>hufigsten Fehler</i>,
                     aber es kann nicht alle mglichen Fehlerquellen entdecken.</P>
  <HR>
  <P class=kommentar align=justify><STRONG>Instructions:</STRONG> This self-diagnosis script performs a number of tests to tell, if your program
                     has been installed correctly. You may check this log-file yourself for error-messages - or, if it still does not work,
                     email me to get help fixing your problem. By doing so, please include a copy of this diagnosis protocol with your mail.
                     Many typical problems may be recognized by reviewing this protocol and you will possibly get an answer for your problem a little faster.</P>
  <P class=kommentar>&bull; If a test fails, <font color=#FF0000>failure-messages</font> are marked red.<BR>
                     &bull; If a test succeeds, <font color=#00A000>success-messages</font> are marked green.<BR>
                     &bull; All <font color=#000000>normal status-information</font> is printed black.</P>
  <P class=kommentar>If you find any red lines: check your configuration for these errors.<BR>
                     Please note: this program detects some of the <i>most common errors</i>, but it does not find all possible problems.</P>
  <HR>
  <P><B>Program is performing self-test now...</b><BR>
  &nbsp;&nbsp;&nbsp;&nbsp;- current Script-Path is: ".__FILE__."<BR>
  &nbsp;&nbsp;&nbsp;&nbsp;- installed version of PHP is: ".PHP_VERSION."</P>
  
  <H1>\tTESTING INSTALLATION:</H1>\n";

  echo "<H2>\tTESTING CONFIGURATION DIRECTORY:</H2>\n";

  $drive = $PROGRAM->registry;
  if (!$drive->exists()) {
    die("<P><font color=#FF0000><b>Critical error:</b> Configuration file ".$drive->filename." cannot be found.</font></P>\n<hr><P>Test aborted due to a critical error.</P>");
  } else {
    echo "<P><font color=#00A000><b>No problems found.</b></font></P>\n";
  }

  checkDrive($drive, $target);

  if ($target=="detailed") {
    echo "<H2>\tAUTOMOUNTING ALL FILES:</H2>\n";
    
    foreach ($PROGRAM->registry->drive as $key => $element) {
      if ($element->mount() && $element->mountpoint->exists()) {
        if (is_readable($element->mountpoint->getFilename())) {
          echo "<font color=#00A000><b>okay</b></font> <span class=KOMMENTAR>&quot;".$element->mountpoint->getFilename()."&quot; is available</span><br>\n";
        } else {
          echo "<font color=#FF0000><b>okay</b></font> <span class=KOMMENTAR>&quot;".$element->mountpoint->getFilename()."&quot; is not readable</span><br>\n";
        }
      } else {
        echo "<font color=#A00000><b>Non-Critical Warning:</b></font> <span class=KOMMENTAR>&quot;".$element->mountpoint->getFilename()."&quot; does not exist.</span><br>\n";
      }
    }
  }

  echo "<H2>\tTESTING PLUGIN CONFIGURATION:</H2>\n";
  $PROGRAM->plugins->mountAll();

  foreach ($PROGRAM->plugins->drive as $id=>$drive) {
     if (!$drive->exists()) {
        echo "<P><font color=#FF0000><b>Critical error:</b> Configuration file ".$drive->filename." cannot be found.</font></P>\n<hr><P>Test aborted due to a critical error.</P>";
     } else {
        echo "<div style=\"background-color:#FFFF00\">&bull; Testing Plugin &quot;$id&quot;:</div>\n";
     }
     echo "<blockquote>\n";
     checkDrive($drive, $target, true);
     echo "</blockquote>\n";
  }
  
  echo "<H1>\tTESTING BACKUP-CONFIGURATION:</H1>\n";
  
  echo "<H2>\tCHECKING PROFILE FOR ERRORS:</H2>\n";
  if (count($PROGRAM->registry->drive['config']->mountpoint->get("PROFILE"))==0) {
    echo "<P><font color=#FF0000><b>Error:</b></font> Configuration is not available.</P>\n";
  } else {
    if ($target=="detailed") {
      echo "<STRONG>Performing deep-scan on file &quot;".$PROGRAM->registry->files['config']->getFilename()."&quot;:</STRONG><BR>\n";
      foreach ($PROGRAM->registry->drive['config']->mountpoint->get("PROFILE") as $key => $element) {
        echo "$key = ".gettype($element)."<BR>\n";
      }
    }
    echo "<P><font color=#00A000><b>No problems found.</b></font></P>
          <DIV CLASS=KOMMENTAR>=&#9658; Profile settings for file &quot;".$PROGRAM->registry->files['config']->getFilename()."&quot; are available.</DIV>\n";
  }
  echo "<H2>\tCHECKING SKIN-SETTINGS:</H2>\n";
  if (count($PROGRAM->registry->drive['skin']->mountpoint->get("*"))==0) {
    echo "<P><font color=#FF0000><b>Error:</b></font> No skin file available.</P>\n";
  } else {
    $test = 0;
    echo "<STRONG>Performing deep-scan on file &quot;".$PROGRAM->registry->files['skin']->getFilename()."&quot;:</STRONG><BR>\n";
    foreach ($PROGRAM->registry->drive['skin']->mountpoint->get("SETTINGS") as $key => $element) {
      echo $key." = ";
      if (file_exists($element)) {
        echo '<font color=#00A000><b>file found</b></font>';
      } else {
        echo '<font color=#FF0000><b>failure: file &quot;$element&quot; not found! Please check if filename is correct</b></font>';
        $test++;
      }
      echo "<BR>\n";
    }
    if ($test>0) echo "<P><font color=#FF0000><b>Warning: $test errors found. This skin might either be corrupt or it was not installed correctly.</FONT></P>\n";
    else         echo "<P><font color=#00A000><b>No problems found.</b></font></P>
          <DIV CLASS=KOMMENTAR>=&#9658; Skin file &quot;".$PROGRAM->registry->files['skin']->getFilename()."&quot; seems to be installed correctly.</DIV>\n";
  }
  echo "<H2>\tSCANING LANGUAGE-FILES:</H2>\n";
  if (count($PROGRAM->registry->drive['language']->mountpoint->get("*"))==0) {
    echo "<P><font color=#FF0000><b>Error:</b></font> No language file available. Please check if this filename is correct: &quot;".$PROGRAM->registry->files['language']->getFilename()."&quot;</P>\n";
  } else {
    if ($target=="detailed") {
      echo "<STRONG>Performing deep-scan on file &quot;".$PROGRAM->registry->files['language']->getFilename()."&quot;:</STRONG><BR>\n";
      foreach ($PROGRAM->registry->drive['language']->mountpoint->get("TMPL") as $key => $element) {
        echo $key." = ".$element."<BR>\n";
      }
    }
    echo "<P><font color=#00A000><b>No problems found.</b></font></P>
          <DIV CLASS=KOMMENTAR>=&#9658; Language file &quot;".$PROGRAM->registry->files['language']->getFilename()."&quot; seems to be installed correctly.</DIV>\n";
  }
  echo "<H2>\tLIST ALL SMILIES:</H2>\n";
  loadSmilies($PROGRAM->registry->files['SMILE']->getFilename());
  global $smilies;
  if (count($smilies)==0) {
    echo "<P><font color=#FF0000><b>Warning:</b></font> No Smilies found. Please check if the given directory is correct: &quot;".$PROGRAM->registry->files['SMILE']->getFilename()."&quot;</P>\n";
  } else {
    echo "<STRONG>&bull; ".count($smilies)." Smilies found in directory &quot;".$PROGRAM->registry->files['SMILE']->getFilename()."&quot;:</STRONG><BR>\n";
    for ($i=0;$i<count($smilies) && $target=="detailed";$i++) {
      echo $smilies[$i].", ";
      if (($i+1)%5==0) echo "<br>\n";
    }
    echo "<P><font color=#00A000><b>No problems found.</b></font></P>
          <DIV CLASS=KOMMENTAR>=&#9658; Directory setting &quot;".$PROGRAM->registry->files['SMILE']->getFilename()."&quot; seems to be correct.</DIV>\n";
  }
  
  echo "<hr><P>\tSelf-Test ended at: ".date("d.m.Y H:i:s",time())."</P>\n</BODY>\n\n</HTML>";
}

function checkDrive($drive, $target, $plugin=false) {
  $drive->read();
  $text = preg_replace("/\t/", "&nbsp;&nbsp;&nbsp;&nbsp;", nl2br(htmlentities($drive->toString())));
  if ($target=="detailed") {
    echo "<H2>\tLIST CONFIGURATION FILES:</H2>\n";
    echo $text; }
  $test = $drive->checkDrive();
  if (!$test) {
    echo "<P><font color=#00A000><b>All directories successfully installed.</b></font></P>\n";
  } else {
    echo "<P><font color=#FF0000><b>Your configuration contains the following errors:</b></font><BR>\n";
    echo $test."</P>";
  }
  if ($target=="detailed" && !$plugin) {
    echo "<H2>\tSYSTEM-INTEGRITY CHECK:</H2>\n";
    $includes = dirlist($drive->drive['INCLUDES']->mountpoint->filename, $drive->drive['INCLUDES']->mountpoint->filter);
    $root     = dirlist(".", '.php');
    for ($i=0;$i<count($includes);$i++) {
      echo "SYSTEM[includes/".$includes[$i]."] = ".crc32(implode("",file("includes/".$includes[$i])))."<BR>\n";
    }
    for ($i=0;$i<count($root);$i++) {
      echo "SYSTEM[./".$root[$i]."] = ".crc32(implode("",file($root[$i])))."<BR>\n";
    }
  }
}

//  2005, Thomas Meyer www.All-Community.de
// Copyright Hinweis nicht entfernen!
?>
