<?php

class guestbook_admin extends serializeableObject {

   var $id     = "gbuch";
   var $page   = 0;
   var $target = "";
   var $php_self = "";
   var $next_action = "show";
   var $remote_addr = "";

/*********************************************************************************************/

   function guestbook_admin($ARGS) {

      global $lcn_note, $PROGRAM, $REMOTE_ADDR;

      # <... Typsicherheit herstellen
      settype($ARGS, "array");
      settype($lcn_note, "string");
      # ENDE ...>

      if (isset($ARGS['id']) && $ARGS['id'])        $this->id          = strtolower($ARGS['id']);
      if (isset($ARGS['page']) && $ARGS['page']>0)  $this->page        = $ARGS['page'];
      if (isset($ARGS['target']) && $ARGS['target'])$this->target      = $ARGS['target'];
                                                    $this->php_self    = $PROGRAM->getRegistryKey("PHP_SELF");
      if (isset($ARGS['action']) && $ARGS['action'])$this->next_action = $ARGS['action'];
                                                    $this->remote_addr = $REMOTE_ADDR;

      # Initialisiere
      $PROGRAM->setRegistryKey("ID",         $this->id);
      $PROGRAM->setRegistryKey("PAGE",       $this->page);
      $PROGRAM->setRegistryKey("TARGET",     $this->target);
      $PROGRAM->setRegistryKey("REMOTE_ADDR",$this->remote_addr);
   }

/*********************************************************************************************/

    function get_edit($mode) {
      global $PROGRAM;

      $REF = array();
      switch ($mode) {
        case 1:
          $REF['BESCHREIBUNG'] = $PROGRAM->getRegistryKey("LANGUAGE/DESCR_ADMIN");
        break;
        case 2:
          $REF['BESCHREIBUNG'] = $PROGRAM->getRegistryKey("LANGUAGE/DESCR_MOD");
        break;
        default:
          $REF['BESCHREIBUNG'] = $PROGRAM->getRegistryKey("LANGUAGE/DESCR_CREATE");
        break;
      }
      $REF                += $this->genButtons($this->next_action,"");
      $REF['LANGFILE']     = $PROGRAM->registry->files['LANG']->getContent();
      $REF['SKINFILE']     = $PROGRAM->registry->files['SKIN']->getContent();
      $REF['PROFILE']      = $PROGRAM->registry->files['CONFIG']->getContent();

      $REF['WRITEABLE']    = $PROGRAM->registry->files['config']->is_writeable();
      $PROGRAM->registry->merge("", $REF);
    }

    function set_create($INPUT) {
      settype($INPUT, "array");
      global $PROGRAM;

      $file = ($PROGRAM->registry->files['CONFIG']->getFilename()).($this->id).".cfg";
      if (file_exists($file)) { $PROGRAM->meldung("fehler", "allready_exists", "index"); }
      $PROGRAM->registry->files['config']->init();
      $PROGRAM->registry->files['config'] = new configfile($file);
      $PROGRAM->registry->files['config']->create();
      $PROGRAM->registry->files['config']->set(mergeArrays($PROGRAM->registry->files['config']->get('*'),$this->genAdminFile($INPUT)));

      if (!$PROGRAM->registry->files['config']->failSafeWrite()) { $PROGRAM->meldung("fehler", "500", "index"); };
      $PROGRAM->meldung("danke", "200", "index");
    }

    function set_admin($INPUT) {
      settype($INPUT, "array");
      global $PROGRAM;

      $PROGRAM->registry->files['config']->init();
      $PROGRAM->registry->files['config']->insert($this->genAdminFile($INPUT));

      if (!$PROGRAM->registry->files['config']->failSafeWrite()) { $PROGRAM->meldung("fehler", "500", "index"); };
      $PROGRAM->meldung("danke", "200", "index");
    }


/*********************************************************************************************/

   function genLink($action, $target, $page) {
      settype($action, "string");
      settype($target, "string");
      settype($page, "string");

      if ($action=="*") $action = $this->next_action;
      if ($target=="*") $target = $this->target;
      if ($page=="*")   $page = $this->page;
      return $this->php_self."?action=".$action."&amp;page=".$page."&amp;id=".$this->id."&amp;target=".$target."&amp;".session_name()."=".session_id();
   }

   function genButtons($action,$target) {
      settype($action, "string");
      settype($target, "string");
      global $PROGRAM;

      $REF = array();
      $vers = array("",1,2);
      $btns = array("SHOW","DETAILS","NEW");
      $dir = $PROGRAM->getRegistryKey("LANGUAGEDIR");

      for ($x=0;$x<count($btns);$x++) {
          for ($i=0;$i<count($vers);$i++) { 
            $REF[current($btns).current($vers)] = '<a href="'.$this->genLink(current($btns),(current($btns)==$action) ? $target : '','*').'" '.
                                             'title="'.$PROGRAM->getRegistryKey("LANGUAGE/TITLE_".current($btns)).'">'.
                                             '<img src="'.$dir.$PROGRAM->getRegistryKey("TMPL/".strtoupper(current($btns)).current($vers)."/".
                                             ( (strcasecmp(current($btns),$action)) ? 'OFF' : 'ON' )).'" border=0></a>';
            next($vers);
          }
          reset($vers);
          next($btns);
      }
      return $REF;
   }

/*********************************************************************************************/

   /* private Hashtable */ function genAdminFile(/* Hashtable */ $INPUT) {
      settype($INPUT, "array");

      foreach ($INPUT as $key=>$element) {
        settype($element, "string");
        unset($INPUT[$key]);
        $INPUT[strtoupper($key)] = strip_tags($element);
      }

      settype($INPUT['FLOODING'],"integer");
      settype($INPUT['ENTPERPAGE'],"integer");
      settype($INPUT['TIMEFORMAT'],"integer");
      settype($INPUT['NOTIFICATION'],"boolean");
      settype($INPUT['SENDMAIL'],"boolean");

      $REF = array();
      if (isset($INPUT['MYMAIL']))       $REF['PROFILE']['MYMAIL']       = $INPUT['MYMAIL'];
      if (isset($INPUT['NOREPLY']))      $REF['PROFILE']['NOREPLY']      = $INPUT['NOREPLY'];
      if (isset($INPUT['NOTIFICATION'])) $REF['PROFILE']['NOTIFICATION'] = $INPUT['NOTIFICATION'];
      if (isset($INPUT['SENDMAIL']))     $REF['PROFILE']['SENDMAIL']     = $INPUT['SENDMAIL'];
      if (isset($INPUT['FLOODING']))     $REF['PROFILE']['FLOODING']     = $INPUT['FLOODING'];
      if (isset($INPUT['ENTPERPAGE']))   $REF['PROFILE']['ENTPERPAGE']   = $INPUT['ENTPERPAGE'];
      if (isset($INPUT['AUTO']))         $REF['PROFILE']['AUTO']         = $INPUT['AUTO'];
      if (isset($INPUT['BGCOLOR']))      $REF['PROFILE']['BGCOLOR']      = $INPUT['BGCOLOR'];
      if (isset($INPUT['BGIMAGE']))      $REF['PROFILE']['BGIMAGE']      = $INPUT['BGIMAGE'];
      if (isset($INPUT['LOGO']))         $REF['PROFILE']['LOGO']         = $INPUT['LOGO'];
      if (isset($INPUT['HFONT']))        $REF['PROFILE']['HFONT']        = $INPUT['HFONT'];
      if (isset($INPUT['HSIZE']))        $REF['PROFILE']['HSIZE']        = $INPUT['HSIZE'];
      if (isset($INPUT['HCOLOR']))       $REF['PROFILE']['HCOLOR']       = $INPUT['HCOLOR'];
      if (isset($INPUT['PFONT']))        $REF['PROFILE']['PFONT']        = $INPUT['PFONT'];
      if (isset($INPUT['PSIZE']))        $REF['PROFILE']['PSIZE']        = $INPUT['PSIZE'];
      if (isset($INPUT['PCOLOR']))       $REF['PROFILE']['PCOLOR']       = $INPUT['PCOLOR'];
      if (isset($INPUT['TIMEFORMAT']))   $REF['PROFILE']['TIMEFORMAT']   = $INPUT['TIMEFORMAT'];
      if (isset($INPUT['USERMODE']))     $REF['PROFILE']['USERMODE']     = $INPUT['USERMODE'];
      if (isset($INPUT['SKIN']))         $REF['PROFILE']['SKIN']         = $INPUT['SKIN'];
      if (isset($INPUT['LANGUAGE']))     $REF['PROFILE']['LANGUAGE']     = $INPUT['LANGUAGE'];
      if (isset($INPUT['FILE']))         $REF['PROFILE']['FILE']         = $INPUT['FILE'];
      if (isset($INPUT['SMILEYDIR']))    $REF['PROFILE']['SMILEYDIR']    = $INPUT['SMILEYDIR'];

      return $REF;
   }
   
   /* public void */ function setId(/* String */ $id) {
     settype($id, "string");
     $this->id = strtolower($id);
   }

} // class

//  2004, Thomas Meyer www.All-Community.de
// Copyright Hinweis nicht entfernen!
?>
