<?php

/* public */ class plugin_ipblock_admin extends plugin {

  /* private blockfile */ var $whitelist;
  /* private blockfile */ var $blacklist;
  /* private dirStream */ var $dir;

  /* constructor */ function plugin_ipblock_admin($plugin_name) {
    settype($plugin_name,"string");        
    global $PROGRAM;
    
    $this->plugin_name = $plugin_name;
    $this->whitelist = $PROGRAM->plugins->get($this->plugin_name,"IPWHITELIST");
    $this->blacklist = $PROGRAM->plugins->get($this->plugin_name,"IPBLACKLIST");
    $this->dir       = $PROGRAM->plugins->get($this->plugin_name,"BLOCKDIR");
  }

  /* public void */ function listener(/* String */ $event, /* Hashtable */ $ARGS) {
    settype($event, "string");
    settype($ARGS, "array");

    if ($this->blacklist && $this->whitelist) {
      if ($this->whitelist->exists()) $this->whitelist->read();
      if ($this->blacklist->exists()) $this->blacklist->read();

      global $PROGRAM;
      $PROGRAM->setRegistryKey("ID",$ARGS['id']);

      switch ($event) {

        case "get_block":
               $PROGRAM->setRegistryKey("BLACKLIST", $this->blacklist->get());
               $PROGRAM->setRegistryKey("WHITELIST", $this->whitelist->get());
               $PROGRAM->registry->mount("language_block_file");
               return true;
        break;

        case "get_root_block":
               $PROGRAM->setRegistryKey("BLACKLIST", $this->blacklist->get());
               $PROGRAM->setRegistryKey("WHITELIST", $this->whitelist->get());
               $PROGRAM->registry->mount("language_block_file");
               return true;
        break;

        case "set_block":
               $this->blacklist = new blockfile($this->dir->getFilename()."blacklist_".$ARGS['id'].".cfg");
               $this->whitelist = new blockfile($this->dir->getFilename()."whitelist_".$ARGS['id'].".cfg");

               if ($this->whitelist->exists()) { $this->whitelist->read(); }
               if ($this->blacklist->exists()) { $this->blacklist->read(); }

               return $this->set($ARGS);
        break;

        case "set_root_block":
               return $this->set($ARGS);
        break;

        default:
        break;
      } # end switch
    }
    return true;
  }
  
  /* private boolean */ function set(/* Hashtable */ $ARGS) {
     settype($ARGS, "array");
     global $PROGRAM;

     if (!$this->whitelist->exists()) {
       if (!$this->whitelist->create()) {
         $PROGRAM->meldung("fehler", "500", "index");
         return false;
       }
     }

     if (!$this->blacklist->exists()) {
       if (!$this->blacklist->create()) {
         $PROGRAM->meldung("fehler", "500", "index");
         return false;
       }
     }

     if ((!$this->blacklist->set($ARGS['blacklist']) || !$this->blacklist->write()) ||
         (!$this->whitelist->set($ARGS['whitelist']) || !$this->whitelist->write()))
     {
       $PROGRAM->meldung("fehler", "500", "index");
       return false;
     } else {
       $PROGRAM->meldung("danke", "200", "index");
       return false;
     }
  }

}

//  2004, Thomas Meyer www.All-Community.de
// Copyright Hinweis nicht entfernen!
?>
